<template>
    <AdminMenuBar>
        <div class="flex items-center items-justify">
            <el-card v-loading="loading" class="flex items-center items-justify" style="width:600px;">
                <h1 class="font-size-lg no-margin">Update</h1>
                <p class="margin-bottom-md">You can leave the passwords blank, if you only wanted to change your name or
                    email.</p>
                <el-form ref="formRef" :model="form" :size="formSize" :rules="rules">
                    <template v-for="item in formItems">
                        <hr class="margin-top-md margin-bottom-md" v-if="item.id == 'password'"/>
                        <el-form-item  :prop="item.id">
                        <el-input :class="item.class" :type="item.type" :id="item.id" v-model="form[item.id]"
                            :placeholder="item.placeholder" :show-password="item.type == 'password'" />
                    </el-form-item>
                    </template>
                
                    <el-form-item class="">
                        <el-button @click="update">Update</el-button>
                        <el-button @click="getAdminData">Reset</el-button>
                    </el-form-item>
                    <el-form-item>

                    </el-form-item>
                </el-form>
            </el-card>
        </div>

    </AdminMenuBar>
</template>

<script setup>
import { ref, onMounted } from "vue"
import formHelper from "../../helpers/form"
import { ElMessageBox } from "element-plus";
import { notify } from "../../common/notification";

const { formSize, formRef, form, resetForm, rules } = formHelper

const loading = ref(false);
const data = ref([]);

const formItems = ref(
    [
        {
            id: 'name',
            type: 'name',
            placeholder: 'New Name',
        },
        {
            id: 'email',
            type: 'email',
            placeholder: "New Email"
        },
        {
            'id': 'password',
            'type': 'password',
            placeholder: 'Old password'
        },
        {
            id: 'new_password',
            type: 'password',
            placeholder: 'New Password'
        },
        {
            id: "new_password_confirmation",
            placeholder: "Confirm New Password",
            type: "password",
        },
    ]
);

const update = async () => {

    ElMessageBox.confirm(
        "Are you sure you want to update your account?",
        "Warning",
        {
            cancelButtonText: "Cancel",
            confirmButtonText: "Confirm",
            type: "warning",
        }
    ).then(async () => {
        loading.value = true;
        const filteredObject = Object.keys(form.value).reduce((result, key) => {
            if (
                key.includes('name') ||
                key.includes('email') ||
                key.includes('password') ||
                key.includes('new_password') ||
                key.includes('new_password_confirmation')
            ) {
                result[key] = form.value[key];
            }
            return result;
        }, {});


        let token = localStorage.getItem("admin_token") ?? sessionStorage.getItem("admin_token");
        const headers = {
            Authorization: `Bearer ${token}`,
        };

        await axios({
            method: "POST",
            url: "/api/admin/update",
            data: filteredObject,
            headers: headers,
        });

        notify("Success!", "You succecssfully updated your account", 1);
    })
        .catch((error) => {
            console.log(error);
            
            notify("Error", error?.response?.data?.message ?? "Something went wrong.", 4);
        }).finally(() => {
            loading.value = false;
            resetForm();
            getAdminData();
        });
};

const getAdminData = async () => {
    // resetForm();
    const getAdmins_URL = '/api/admin/getAdminData'
    try {
        loading.value = true;

        const headers = { Authorization: `Bearer ${localStorage.getItem("admin_token") ?? sessionStorage.getItem("admin_token")}` };
        const response = await axios({
            method: 'GET',
            url: getAdmins_URL,
            headers: headers,
        });
        form.value = response.data;

        console.log(response);
    } catch (error) {
        data.value = [];
        console.log(error);
        notify("Error", error?.response?.data?.message ?? "Something went wrong.", 4);
        loading.value = false;
    } finally {
        loading.value = false;
    }
};

onMounted ( () => {
    getAdminData();
});

</script>